package subspecialist

import (
	"net/http"

	rw "github.com/karincake/risoles"
	// ua "github.com/karincake/tumpeng/auth/svc"

	e "simrs-vx/internal/domain/main-entities/subspecialist"
	esync "simrs-vx/internal/domain/sync-entities/log"
	u "simrs-vx/internal/use-case/simgos-sync-use-case/new/subspecialist"
)

type myBase struct{}

var O myBase

func (obj myBase) Create(w http.ResponseWriter, r *http.Request) {
	dto := e.CreateDto{}
	if res := rw.ValidateStructByIOR(w, r.Body, &dto); !res {
		return
	}
	res, err := u.Create(dto)
	rw.DataResponse(w, res, err)
}

func (obj myBase) CreateLog(w http.ResponseWriter, r *http.Request) {
	dto := esync.SimxLogDto{}
	if res := rw.ValidateStructByIOR(w, r.Body, &dto); !res {
		return
	}
	res, err := u.CreateSimxLog(dto)
	rw.DataResponse(w, res, err)
}

func (obj myBase) Update(w http.ResponseWriter, r *http.Request) {
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}

	dto := e.UpdateDto{}
	if res := rw.ValidateStructByIOR(w, r.Body, &dto); !res {
		return
	}

	val := uint16(id)
	dto.Id = &val

	res, err := u.Update(dto)
	rw.DataResponse(w, res, err)
}

func (obj myBase) Delete(w http.ResponseWriter, r *http.Request) {
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}

	dto := e.DeleteDto{}
	val := uint16(id)
	dto.Id = &val

	res, err := u.Delete(dto)
	rw.DataResponse(w, res, err)
}
